Index: trunk/NEMO/LIM_SRC_2/limrhg_2.F90
===================================================================
--- trunk/NEMO/LIM_SRC_2/limrhg_2.F90	(revision 873)
+++ trunk/NEMO/LIM_SRC_2/limrhg_2.F90	(revision 888)
@@ -4,35 +4,42 @@
    !!   Ice rheology :  performs sea ice rheology
    !!======================================================================
+   !! History :  0.0  !  93-12  (M.A. Morales Maqueda.)  Original code
+   !!            1.0  !  94-12  (H. Goosse) 
+   !!            2.0  !  03-12  (C. Ethe, G. Madec)  F90, mpp
+   !!            " "  !  06-08  (G. Madec)  surface module, ice-stress at I-point
+   !!            " "  !  09-09  (G. Madec)  Huge verctor optimisation
+   !!----------------------------------------------------------------------
 #if defined key_lim2
    !!----------------------------------------------------------------------
    !!   'key_lim2'                                    LIM 2.0 sea-ice model
    !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
    !!   lim_rhg_2   : computes ice velocities
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE phycst
-   USE par_oce
-   USE ice_oce         ! ice variables
-   USE dom_ice_2
-   USE ice_2
-   USE lbclnk
-   USE lib_mpp
-   USE in_out_manager  ! I/O manager
-   USE prtctl          ! Print control
+   USE par_oce        ! ocean parameter
+   USE ice_oce        ! ice variables
+   USE sbc_ice        ! surface boundary condition: ice variables
+   USE dom_ice_2      ! domaine: ice variables
+   USE phycst         ! physical constant
+   USE ice_2          ! ice variables
+   USE lbclnk         ! lateral boundary condition
+   USE lib_mpp        ! MPP library
+   USE in_out_manager ! I/O manager
+   USE prtctl         ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC lim_rhg_2  ! routine called by lim_dyn_2
-
-   !! * Module variables
-   REAL(wp)  ::           &  ! constant values
-      rzero   = 0.e0   ,  &
-      rone    = 1.e0
-   !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   PUBLIC   lim_rhg_2 ! routine called by lim_dyn
+
+   REAL(wp) ::   rzero   = 0.e0   ! constant value: zero
+   REAL(wp) ::   rone    = 1.e0   !            and  one
+
+   !! * Substitutions
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2006) 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -48,47 +55,79 @@
       !!  viscous-plastic law including shear strength and a bulk rheology.
       !!
-      !! ** Action  : - compute u_ice, v_ice the sea-ice velocity
+      !! ** Action  : - compute ui_ice, vi_ice the sea-ice velocity defined
+      !!              at I-point
+      !!-------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   k_j1    ! southern j-index for ice computation
+      INTEGER, INTENT(in) ::   k_jpj   ! northern j-index for ice computation
       !!
-      !! History :
-      !!   0.0  !  93-12  (M.A. Morales Maqueda.)  Original code
-      !!   1.0  !  94-12  (H. Goosse) 
-      !!   2.0  !  03-12  (C. Ethe, G. Madec)  F90, mpp
+      INTEGER ::   ji, jj              ! dummy loop indices
+      INTEGER ::   iter, jter          ! temporary integers
+      CHARACTER (len=50) ::   charout
+      REAL(wp) ::   ze11  , ze12  , ze22  , ze21       ! temporary scalars
+      REAL(wp) ::   zt11  , zt12  , zt21  , zt22       !    "         "
+      REAL(wp) ::   zvis11, zvis21, zvis12, zvis22     !    "         "
+      REAL(wp) ::   zgphsx, ztagnx, zunw, zur, zusw    !    "         "
+      REAL(wp) ::   zgphsy, ztagny, zvnw, zvr          !    "         "
+      REAL(wp) ::   zresm,  za, zac, zmod
+      REAL(wp) ::   zmpzas, zstms, zindu, zusdtp, zmassdt, zcorlal
+      REAL(wp) ::   ztrace2, zdeter, zdelta, zmask, zdgp, zdgi, zdiag
+      REAL(wp) ::   za1, zb1, zc1, zd1
+      REAL(wp) ::   za2, zb2, zc2, zd2, zden
+      REAL(wp) ::   zs11_11, zs11_12, zs11_21, zs11_22
+      REAL(wp) ::   zs12_11, zs12_12, zs12_21, zs12_22
+      REAL(wp) ::   zs21_11, zs21_12, zs21_21, zs21_22
+      REAL(wp) ::   zs22_11, zs22_12, zs22_21, zs22_22
+      REAL(wp), DIMENSION(jpi,  jpj  ) ::   zfrld, zmass, zcorl
+      REAL(wp), DIMENSION(jpi,  jpj  ) ::   za1ct, za2ct, zresr
+      REAL(wp), DIMENSION(jpi,  jpj  ) ::   zc1u, zc1v, zc2u, zc2v
+      REAL(wp), DIMENSION(jpi,  jpj  ) ::   zsang
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zu0, zv0
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zu_n, zv_n
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zu_a, zv_a
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zviszeta, zviseta
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zzfrld, zztms
+      REAL(wp), DIMENSION(jpi,0:jpj+1) ::   zi1, zi2, zmasst, zpresh
+
       !!-------------------------------------------------------------------
-      ! * Arguments
-      INTEGER, INTENT(in) ::   k_j1 ,  &  ! southern j-index for ice computation
-         &                     k_jpj      ! northern j-index for ice computation
-
-      ! * Local variables
-      INTEGER ::   ji, jj              ! dummy loop indices
-
-      INTEGER  :: &
-         iim1, ijm1, iip1 , ijp1   , & ! temporary integers
-         iter, jter                    !    "          "
-
-      CHARACTER (len=50) :: charout
-
-      REAL(wp) :: &
-         ze11  , ze12  , ze22  , ze21  ,   &  ! temporary scalars
-         zt11  , zt12  , zt21  , zt22  ,   &  !    "         "
-         zvis11, zvis21, zvis12, zvis22,   &  !    "         "
-         zgphsx, ztagnx, zusw  ,           &  !    "         "
-         zgphsy, ztagny                       !    "         "
-      REAL(wp) :: &
-         zresm, zunw, zvnw, zur, zvr, zmod, za, zac, &
-         zmpzas, zstms, zindu, zindu1, zusdtp, zmassdt, zcorlal,  &
-         ztrace2, zdeter, zdelta, zsang, zmask, zdgp, zdgi, zdiag
-      REAL(wp),DIMENSION(jpi,jpj) ::   &
-         zpresh, zfrld, zmass, zcorl,     &
-         zu0, zv0, zviszeta, zviseta,     &
-         zc1u, zc1v, zc2u, zc2v, za1ct, za2ct, za1, za2, zb1, zb2,  &
-         zc1, zc2, zd1, zd2, zden, zu_ice, zv_ice, zresr
-      REAL(wp),DIMENSION(jpi,jpj,2,2) :: &
-         zs11, zs12, zs22, zs21
-      !!-------------------------------------------------------------------
+
+!!bug
+!!    ui_oce(:,:) = 0.e0
+!!    vi_oce(:,:) = 0.e0
+!!    write(*,*) 'rhg min, max u & v', maxval(ui_oce), minval(ui_oce), maxval(vi_oce), minval(vi_oce)
+!!bug
       
       !  Store initial velocities
-      !  ------------------------
-      zu0(:,:) = u_ice(:,:)
-      zv0(:,:) = v_ice(:,:)
+      !  ----------------
+      zztms(:,0    ) = 0.e0       ;    zzfrld(:,0    ) = 0.e0
+      zztms(:,jpj+1) = 0.e0       ;    zzfrld(:,jpj+1) = 0.e0
+      zu0(:,0    ) = 0.e0         ;    zv0(:,0    ) = 0.e0
+      zu0(:,jpj+1) = 0.e0         ;    zv0(:,jpj+1) = 0.e0
+      zztms(:,1:jpj) = tms(:,:)   ;    zzfrld(:,1:jpj) = frld(:,:)
+      zu0(:,1:jpj) = ui_ice(:,:)   ;    zv0(:,1:jpj) = vi_ice(:,:)
+
+      zu_a(:,:)    = zu0(:,:)     ;   zv_a(:,:) = zv0(:,:)
+      zu_n(:,:)    = zu0(:,:)     ;   zv_n(:,:) = zv0(:,:)
+
+!i
+      zi1   (:,:) = 0.e0
+      zi2   (:,:) = 0.e0
+      zpresh(:,:) = 0.e0
+      zmasst(:,:) = 0.e0
+!i
+!!gm violant
+      zfrld(:,:) =0.e0
+      zcorl(:,:) =0.e0
+      zmass(:,:) =0.e0
+      za1ct(:,:) =0.e0
+      za2ct(:,:) =0.e0
+!!gm end
+
+      zviszeta(:,:) = 0.e0
+      zviseta (:,:) = 0.e0
+
+!i    zviszeta(:,0    ) = 0.e0    ;    zviseta(:,0    ) = 0.e0
+!i    zviszeta(:,jpj  ) = 0.e0    ;    zviseta(:,jpj  ) = 0.e0
+!i    zviszeta(:,jpj+1) = 0.e0    ;    zviseta(:,jpj+1) = 0.e0
+
 
       ! Ice mass, ice strength, and wind stress at the center            |
@@ -96,15 +135,16 @@
       !-------------------------------------------------------------------
 
+!CDIR NOVERRCHK
       DO jj = k_j1 , k_jpj-1
+!CDIR NOVERRCHK
          DO ji = 1 , jpi
-            za1(ji,jj)    = tms(ji,jj) * ( rhosn * hsnm(ji,jj) + rhoic * hicm(ji,jj) )
+            ! only the sinus changes its sign with the hemisphere
+            zsang(ji,jj)  = SIGN( 1.e0, fcor(ji,jj) ) * sangvg   ! only the sinus changes its sign with the hemisphere
+            !
+            zmasst(ji,jj) = tms(ji,jj) * ( rhosn * hsnm(ji,jj) + rhoic * hicm(ji,jj) )
             zpresh(ji,jj) = tms(ji,jj) *  pstarh * hicm(ji,jj) * EXP( -c_rhg * frld(ji,jj) )
-#if defined key_lim_cp1 && defined key_coupled
-            zb1(ji,jj)    = tms(ji,jj) * gtaux(ji,jj) * ( 1.0 - frld(ji,jj) )
-            zb2(ji,jj)    = tms(ji,jj) * gtauy(ji,jj) * ( 1.0 - frld(ji,jj) )
-#else
-            zb1(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )
-            zb2(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )
-#endif
+!!gm  :: stress given at I-point (F-point for the ocean) only compute the ponderation with the ice fraction (1-frld)
+            zi1(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )
+            zi2(ji,jj)    = tms(ji,jj) * ( 1.0 - frld(ji,jj) )
          END DO
       END DO
@@ -117,13 +157,13 @@
          
       DO jj = k_j1+1, k_jpj-1
-         DO ji = 2, jpi
-            zstms = tms(ji,jj  ) * wght(ji,jj,2,2) + tms(ji-1,jj  ) * wght(ji,jj,1,2)   &
-               &  + tms(ji,jj-1) * wght(ji,jj,2,1) + tms(ji-1,jj-1) * wght(ji,jj,1,1)
+         DO ji = fs_2, jpi
+            zstms = zztms(ji,jj  ) * wght(ji,jj,2,2) + zztms(ji-1,jj  ) * wght(ji,jj,1,2)   &
+               &  + zztms(ji,jj-1) * wght(ji,jj,2,1) + zztms(ji-1,jj-1) * wght(ji,jj,1,1)
             zusw  = 1.0 / MAX( zstms, epsd )
 
-            zt11 = tms(ji  ,jj  ) * frld(ji  ,jj  ) 
-            zt12 = tms(ji-1,jj  ) * frld(ji-1,jj  ) 
-            zt21 = tms(ji  ,jj-1) * frld(ji  ,jj-1) 
-            zt22 = tms(ji-1,jj-1) * frld(ji-1,jj-1)
+            zt11 = zztms(ji  ,jj  ) * zzfrld(ji  ,jj  ) 
+            zt12 = zztms(ji-1,jj  ) * zzfrld(ji-1,jj  ) 
+            zt21 = zztms(ji  ,jj-1) * zzfrld(ji  ,jj-1) 
+            zt22 = zztms(ji-1,jj-1) * zzfrld(ji-1,jj-1)
 
             ! Leads area.
@@ -131,21 +171,15 @@
                &             + zt21 * wght(ji,jj,2,1) + zt22 * wght(ji,jj,1,1) ) * zusw
 
-            ! Mass and coriolis coeff.
-            zmass(ji,jj) = ( za1(ji,jj  ) * wght(ji,jj,2,2) + za1(ji-1,jj  ) * wght(ji,jj,1,2)   &
-               &           + za1(ji,jj-1) * wght(ji,jj,2,1) + za1(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw
+            ! Mass and coriolis coeff. at I-point
+            zmass(ji,jj) = ( zmasst(ji,jj  ) * wght(ji,jj,2,2) + zmasst(ji-1,jj  ) * wght(ji,jj,1,2)   &
+               &           + zmasst(ji,jj-1) * wght(ji,jj,2,1) + zmasst(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw
             zcorl(ji,jj) = zmass(ji,jj) * fcor(ji,jj)
 
             ! Wind stress.
-#if defined key_lim_cp1 && defined key_coupled
-            ztagnx = ( zb1(ji,jj  ) * wght(ji,jj,2,2) + zb1(ji-1,jj  ) * wght(ji,jj,1,2)   &
-               &     + zb1(ji,jj-1) * wght(ji,jj,2,1) + zb1(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw
-            ztagny = ( zb2(ji,jj  ) * wght(ji,jj,2,2) + zb2(ji-1,jj  ) * wght(ji,jj,1,2)   &
-               &     + zb2(ji,jj-1) * wght(ji,jj,2,1) + zb2(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw
-#else
-            ztagnx = ( zb1(ji,jj  ) * wght(ji,jj,2,2) + zb1(ji-1,jj  ) * wght(ji,jj,1,2)   &
-               &     + zb1(ji,jj-1) * wght(ji,jj,2,1) + zb1(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw * gtaux(ji,jj)
-            ztagny = ( zb2(ji,jj  ) * wght(ji,jj,2,2) + zb2(ji-1,jj  ) * wght(ji,jj,1,2)   &
-               &     + zb2(ji,jj-1) * wght(ji,jj,2,1) + zb2(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw * gtauy(ji,jj)
-#endif
+            ! always provide stress at I-point (ocean F-point)
+            ztagnx = ( zi1(ji,jj  ) * wght(ji,jj,2,2) + zi1(ji-1,jj  ) * wght(ji,jj,1,2)   &
+               &     + zi1(ji,jj-1) * wght(ji,jj,2,1) + zi1(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw * utaui_ice(ji,jj)
+            ztagny = ( zi2(ji,jj  ) * wght(ji,jj,2,2) + zi2(ji-1,jj  ) * wght(ji,jj,1,2)   &
+               &     + zi2(ji,jj-1) * wght(ji,jj,2,1) + zi2(ji-1,jj-1) * wght(ji,jj,1,1) ) * zusw * vtaui_ice(ji,jj)
 
             ! Gradient of ice strength
@@ -161,13 +195,9 @@
 
             ! Computation of the velocity field taking into account the ice-ice interaction.                                 
-            ! Terms that are independent of the velocity field.
-            za1ct(ji,jj) = ztagnx - zcorl(ji,jj) * v_oce(ji,jj) - zgphsx
-            za2ct(ji,jj) = ztagny + zcorl(ji,jj) * u_oce(ji,jj) - zgphsy
+            ! Terms that are independent of the ice velocity field.
+            za1ct(ji,jj) = ztagnx - zcorl(ji,jj) * vi_oce(ji,jj) - zgphsx
+            za2ct(ji,jj) = ztagny + zcorl(ji,jj) * ui_oce(ji,jj) - zgphsy
          END DO
       END DO
-
-!! inutile!!
-!!??    CALL lbc_lnk( za1ct, 'I', -1. )
-!!??    CALL lbc_lnk( za2ct, 'I', -1. )
 
 
